%define abs2rel() perl -MFile::Spec -e 'print File::Spec->abs2rel(@ARGV)' %1 %2
%global relccache %(%abs2rel %{_bindir}/ccache %{_libdir}/ccache)

Summary:        C/C++ compiler cache
Name:           ccache
Version:        4.7.3
Release:        5%{?dist}
License:        GPLv3+
URL:            http://ccache.dev/
Source0:        https://github.com/ccache/ccache/releases/download/v%{version}/%{name}-%{version}.tar.gz
Source1:        %{name}.sh.in
Source2:        %{name}.csh.in

BuildRequires:  cmake clang clang-tools-extra hiredis-devel libzstd-devel
BuildRequires:  perl perl(File::Spec) /usr/bin/asciidoctor

Requires:       coreutils
Requires(pre):  shadow-utils

%description
ccache is a compiler cache.  It speeds up recompilation of C/C++ code by caching previous compiles and detecting when
the same compile is being done again.  The main focus is to handle the GNU C/C++ compiler (GCC), but it may also work
with compilers that mimic GCC good enough.

%prep
%autosetup -n %{name}-%{version} -p1
sed -e 's|@LIBDIR@|%{_libdir}|g' -e 's|@CACHEDIR@|%{_var}/cache/ccache|g' \
    %{SOURCE1} > %{name}.sh
sed -e 's|@LIBDIR@|%{_libdir}|g' -e 's|@CACHEDIR@|%{_var}/cache/ccache|g' \
    %{SOURCE2} > %{name}.csh

%build
%cmake
%cmake_build
%cmake_build --target doc

%install
rm -rf %{buildroot}

%cmake_install

install -Dpm 644 %{__cmake_builddir}/doc/ccache.1 %{buildroot}%{_mandir}/man1/ccache.1
install -dm 755 %{buildroot}%{_sysconfdir}/profile.d
install -pm 644 %{name}.sh %{name}.csh %{buildroot}%{_sysconfdir}/profile.d
install -dm 770 %{buildroot}%{_var}/cache/ccache

install -dm 755 %{buildroot}%{_libdir}/ccache
for n in cc gcc g++ c++ ; do
    ln -s %{relccache} %{buildroot}%{_libdir}/ccache/$n
    for p in aarch64 ppc64le x86_64 ; do
        ln -s %{relccache} %{buildroot}%{_libdir}/ccache/$p-linux-gnu-$n
    done
    ln -s %{relccache} \
        %{buildroot}%{_libdir}/ccache/%{_target_cpu}-%{_vendor}-%{_target_os}-$n
done
for n in clang clang++ ; do
    ln -s %{relccache} %{buildroot}%{_libdir}/ccache/$n
done
find %{buildroot}%{_libdir}/ccache -type l | \
    sed -e "s|^%{buildroot}|%%ghost |" > %{name}-%{version}.compilers

%check
%ctest


%define ccache_trigger(p:) \
%triggerin -- %{-p*}\
for n in %* ; do\
    [ ! -x %{_bindir}/$n ] || ln -sf %{relccache} %{_libdir}/ccache/$n\
    [ ! -x %{_bindir}/%{_target_cpu}-%{_vendor}-%{_target_os}-$n ] || \\\
      ln -sf %{relccache} %{_libdir}/ccache/%{_target_cpu}-%{_vendor}-%{_target_os}-$n\
done\
:\
%triggerpostun -- %{-p*}\
for n in %* ; do\
    [ -x %{_bindir}/$n ] || rm -f %{_libdir}/ccache/$n\
    [ -x %{_bindir}/%{_target_cpu}-%{_vendor}-%{_target_os}-$n ] || \\\
        rm -f %{_libdir}/ccache/%{_target_cpu}-%{_vendor}-%{_target_os}-$n\
done\
:\
%{nil}

%ccache_trigger -p clang clang clang++
%ccache_trigger -p gcc cc gcc
%ccache_trigger -p gcc-c++ c++ g++
%ccache_trigger -p gcc-aarch64-linux-gnu aarch64-linux-gnu-gcc
%ccache_trigger -p gcc-c++-aarch64-linux-gnu aarch64-linux-gnu-c++ aarch64-linux-gnu-g++
%ccache_trigger -p gcc-sh-linux-gnu sh-linux-gnu-gcc
%ccache_trigger -p gcc-c++-sh-linux-gnu sh-linux-gnu-c++ sh-linux-gnu-g++
%ccache_trigger -p gcc-x86_64-linux-gnu x86_64-linux-gnu-gcc
%ccache_trigger -p gcc-c++-x86_64-linux-gnu x86_64-linux-gnu-c++ x86_64-linux-gnu-g++

%pre
getent group ccache >/dev/null || groupadd -r ccache || :

%files -f %{name}-%{version}.compilers
%license GPL-3.0.txt LICENSE.*
%doc doc/AUTHORS.*  doc/MANUAL.* doc/NEWS.* README.md
%config(noreplace) %{_sysconfdir}/profile.d/%{name}.*sh
%{_bindir}/ccache
%dir %{_libdir}/ccache/
%attr(2770,root,ccache) %dir %{_var}/cache/ccache/
%{_mandir}/man1/ccache.1*

%changelog
* Mon Dec 25 2023 luffyluo <luffyluo@tencent.com> - 4.7.3-5
- Rebuilt for llvm 17.0.6

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.7.3-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.7.3-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.7.3-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Dec 9 2022 Shuo Wang <abushwang@tencent.com> - 4.7.3-1
- initial build

